package cz.cvut.fit.biand.tutorial7;

import android.app.ListActivity;
import android.content.Context;
import android.database.Cursor;
import android.os.AsyncTask;
import android.os.Bundle;
import android.provider.ContactsContract;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.CursorAdapter;
import android.widget.TextView;
import cz.cvut.fit.biand.tutorial7final.R;

public class ContactsActivity extends ListActivity {

	private class LoadContactsTask extends AsyncTask<Void, Void, Cursor> {
		@Override
		protected Cursor doInBackground(Void... params) {
			return managedQuery(ContactsContract.Contacts.CONTENT_URI,
					new String[] { ContactsContract.Contacts._ID,
							ContactsContract.Contacts.DISPLAY_NAME },
					ContactsContract.Contacts.IN_VISIBLE_GROUP + "=1", null,
					ContactsContract.Contacts.DISPLAY_NAME);
		}

		@Override
		protected void onPostExecute(Cursor result) {
			if (result != null) {
				setupAdapter(result);
			}
		}
	};

	private static class ContactsAdapter extends CursorAdapter {
		LayoutInflater inflater;
		int nameColumn;

		static class ViewHolder {
			TextView text;
		}

		public ContactsAdapter(Context context, Cursor c) {
			super(context, c, false);
			inflater = LayoutInflater.from(context);
			nameColumn = c
					.getColumnIndex(ContactsContract.Contacts.DISPLAY_NAME);
		}

		@Override
		public void bindView(View view, Context context, Cursor cursor) {
			ViewHolder holder = (ViewHolder) view.getTag();
			holder.text.setText(cursor.getString(nameColumn));
		}

		@Override
		public View newView(Context context, Cursor cursor, ViewGroup parent) {
			View view = inflater.inflate(android.R.layout.simple_list_item_1,
					parent, false);
			ViewHolder holder = new ViewHolder();
			holder.text = (TextView) view.findViewById(android.R.id.text1);
			view.setTag(holder);
			return view;
		}
	}

	private LoadContactsTask mLoadContactsTask;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		mLoadContactsTask = new LoadContactsTask();
		mLoadContactsTask.execute();
		
		//getListView().setCacheColorHint(0);
	}

	private void setupAdapter(Cursor cursor) {
		setListAdapter(new ContactsAdapter(this, cursor));
	}

}
